package org.gcube.portlets.user.reportgenerator.client;

import org.gcube.portlets.d4sreporting.common.shared.SerializableModel;
import org.gcube.portlets.d4sreporting.common.shared.SerializableTable;
import org.gcube.portlets.d4sreporting.common.shared.SerializableTimeSeries;
import org.gcube.portlets.user.reportgenerator.client.model.ExportManifestationType;
import org.gcube.portlets.user.reportgenerator.shared.SessionInfo;

import com.google.gwt.user.client.rpc.AsyncCallback;
/**
 *  * Service interface for server Async communication
 * @author Massimiliano Assante, ISTI-CNR - massimiliano.assante@isti.cnr.it
 * 
 * @version november 2011 (3.0) 
 */
 
public interface ReportServiceAsync {
	/**
	 * return the first ten records of the timeseries having id as param
	 * @param sTS .
	 * @param callback .
	 */
	void getSampleTimeSeries(SerializableTimeSeries sTS, AsyncCallback<SerializableTable> callback);
	/**
	 * 
	 * @param callback .
	 */
	void getUserTemplateNames(AsyncCallback<String[]> callback);
	
	/**
	 * 
	 * @param templateName .
	 * @param templateObjectID .
	 * @param isTemplate says if you're opening a template or a report
	 * @param isImporting says if your importing or youre loading a template in the UI
	 * @param callback .
	 */
	void readModel(String templateName, String templateObjectID, boolean isTemplate, boolean isImporting,  AsyncCallback<SerializableModel> callback);
	

	
	/**
	 * @param model .
	 * @param type .
	 * @param callback .
	 */
	void generateManifestation(SerializableModel model, ExportManifestationType type, AsyncCallback<Boolean> callback);
	
	/**
	 * 
	 * @param model .
	 * @param callback .
	 */
	void storeTemplateInSession(SerializableModel model, AsyncCallback<Void> callback);
	/**
	 * 
	 * call for the model previously stored in the session 
	 * @param callback .
	 */
	void readTemplateFromSession( AsyncCallback<SerializableModel> callback);
	
	/**
 	 * @param callback .
	 * @param folderid .
	 */
	void saveReport(String folderid, String newname, AsyncCallback<Void> callback);
	
	/**
	 * 
	 * @param callback .
	 */
	void saveReport(AsyncCallback<Void> callback);
	/**
	 * 
	 * @param currentHost
	 * @param callback
	 */
	void getSessionInfo(String currentHost, AsyncCallback<SessionInfo> callback);
	void getWorkflowDocumentFromDocumentLibrary(
			AsyncCallback<SerializableModel> callback);
	void updateWorkflowDocument(boolean update, AsyncCallback<Void> callback);
	void renewLock(AsyncCallback<Void> callback);
	void generateTempDocx(SerializableModel model,
			AsyncCallback<String> callback);
	void readImportedModel(String tempPath,
			AsyncCallback<SerializableModel> callback);
}
