package org.gcube.portlets.user.reportgenerator.client.targets;

import java.util.ArrayList;

import org.gcube.portlets.d4sreporting.common.client.uicomponents.ReportUIComponent;
import org.gcube.portlets.d4sreporting.common.shared.ComponentType;
import org.gcube.portlets.d4sreporting.common.shared.SerializableComponent;
import org.gcube.portlets.d4sreporting.common.shared.SerializableRepeatableSequence;
import org.gcube.portlets.user.reportgenerator.client.Presenter.Presenter;
import org.gcube.portlets.user.reportgenerator.client.model.TemplateComponent;
import org.gcube.portlets.user.reportgenerator.client.model.TemplateModel;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.VerticalPanel;

public class RepeatableSequence extends ReportUIComponent {
	private ArrayList<TemplateComponent> groupedComponents = new ArrayList<TemplateComponent>();

	VerticalPanel myPanel;
	Presenter p;

	
	/**
	 * constructor used by the system when reading the model 
	 * @param sRS
	 */
	public RepeatableSequence(Presenter p, SerializableRepeatableSequence sRS) {
		super(ComponentType.REPEAT_SEQUENCE, 0, 0, TemplateModel.TEMPLATE_WIDTH - 50, sRS.getHeight());
		this.p = p;
		myPanel = getResizablePanel();

		int size = sRS.getGroupedComponents().size();
		for (int j = 0; j < size; j++) {
			SerializableComponent sComp = sRS.getGroupedComponents().get(j);
			add(new TemplateComponent(p.getModel(), sComp, p));
		}
	}

	public void add(TemplateComponent toAdd) {
		groupedComponents.add(toAdd);
		GWT.log("toAdd.getContent()= NULL? " + (toAdd.getContent() == null));
		GWT.log("ToAdd= getType " + toAdd.getType());
		myPanel.add(toAdd.getContent());
	}

	
	public ArrayList<TemplateComponent> getGroupedComponents() {
		return groupedComponents;
	}

	public void setGroupedComponents(ArrayList<TemplateComponent> groupedComponents) {
		this.groupedComponents = groupedComponents;
	}
	
	public int getHeight() {
		return super.mainPanel.getOffsetHeight();
	}

	@Override
	public void removeTemplateComponent(ReportUIComponent toRemove) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void lockComponent(ReportUIComponent toLock, boolean locked) {
		// TODO Auto-generated method stub
		
	}
}
